<?
/***************************************************************************
 phpTrafficA @soft.ZoneO.net
 Copyright (C) 2004 ZoneO-soft, S. Merkel (dude@zoneo.net)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/


/*********************************************************************************/
/* Function: shorten
/* Role: Shorten a string 
/* Parameters: 
/*   - $var: the string to shorten
/*   - $len: number of characters
/* Output:
/*   - the shorten string
/* Source: php website
/*********************************************************************************/
function shorten ($var, $len = 30) {
  if (empty ($var)) {
    return "";
  }
  if (strlen ($var) < $len) {
    return $var;
  } 
  // if (preg_match ("/(.{1,$len})\s/", $var, $match)) {
  //  return $match [1];
  //}
  //else {
  return substr ($var, 0, $len);
    //}
}

/*********************************************************************************/
/* Function: shortencenter
/* Role: Shorten a string from the center (remove chars at the center)
/* Parameters: 
/*   - $var: the string to shorten
/*   - $len: number of characters
/* Output:
/*   - the shorten string
/* Created: 06/2004
/*********************************************************************************/
function shortencenter ($var, $len = 30) {
  if (empty ($var)) {
    return "";
  }
  if (strlen ($var) < $len) {
    return $var;
  }
  $len = floor($len/2)-1;
  return  substr($var,0,$len)."..".substr ($var,strlen($var)-$len,$len);
}

/*********************************************************************************/
/* Function: nToday
/* Role: number of access to a site today
/* Parameters: 
/*   - $table: base name for sql tables
/*   - $site: root of the website
/* Output:
/*   - number of access
/* Created: 06/2004
/*********************************************************************************/
function nToday($table, $site) {
  global $DEBUG;
  global $server;
  global $user;
  global $password;
  global $base;
  global $config_table;
 
  $today = date("Y-m-d");
  $thismonth = date("Y-m-01");
  
  $c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
  $db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");
  // get total access today WHERE date='$today'
  $req = "SELECT SUM(count) as count FROM ${table}_acces WHERE date='$today';"; 
  $res = mysql_query($req,$c);
  $count=mysql_fetch_array($res);
  @mysql_close ($c);
  if ($count['count'] == "") {
    $c = 0;
  } else {
    $c = $count['count'];
  }
  return $c;
}

/*********************************************************************************/
/* Function: nThisMonth
/* Role: number of access to a site this month
/* Parameters: 
/*   - $table: base name for sql tables
/*   - $site: root of the website
/* Output:
/*   - number of access
/* Created: 06/2004
/*********************************************************************************/
function nThisMonth($table, $site) {
  global $DEBUG;
  global $server;
  global $user;
  global $password;
  global $base;
  global $config_table;
 
  $today = date("Y-m-d");
  $thismonth = date("Y-m-01");
  
  $c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
  $db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");
  // get total access today WHERE date='$today'
  $req = "SELECT SUM(count) as count FROM ${table}_acces WHERE date>='$thismonth' AND date<='$today';"; 
  $res = mysql_query($req,$c);
  $count=mysql_fetch_array($res);
  @mysql_close ($c);
  if ($count['count'] == "") {
    $c = 0;
  } else {
    $c = $count['count'];
  }
  return $c;
}

/*********************************************************************************/
/* Function: dropSQLStructure
/* Role: drops the SQL structures of a group of tables, used in the application design...
/* Parameters: 
/*   - $table: base name for sql tables
/* Output:
/*   - 
/* Created: 06/2004
/*********************************************************************************/
function dropSQLStructure($table) {
  global $DEBUG;
  global $server;
  global $user;
  global $password;
  global $base;
  global $config_table;
  $c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
  $db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");
  $tables[] = $table."_pages";
  $tables[] = $table."_acces";
  $tables[] = $table."_host";
  $tables[] = $table."_country";
  $tables[] = $table."_hour";
  $tables[] = $table."_day";
  $tables[] = $table."_os";
  $tables[] = $table."_browser";
  $tables[] = $table."_keyword";
  $tables[] = $table."_referrer"; 
  foreach ($tables as $thetable) {
    $sql = "show create table $thetable";
    $describe=mysql_query($sql,$c);
    while ($ligne=mysql_fetch_array($describe)){
      //echo "<br>$ligne";
      $str = str_replace("$table", "\${table}", $ligne[1]);
      echo "<br>$str;<br>";
    }
  }

  @mysql_close ($c);
}

/*********************************************************************************/
/* Function: diskUsage
/* Role: drops the detailed disk usage
/* Parameters: 
/* Output:
/* Created: 06/2004
/*********************************************************************************/
function diskUsage () {
  global $server;
  global $user;
  global $password;
  global $base;
  global $sites;

  echo "<table class='simple'>
<tr><td class='title' colspan='3'>Existing databases</td></tr>
<tr><td class='caption'>Domain</td><td class='caption'>Table</td><td class='caption'>Disk usage</td></tr>";
  $c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
  $db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");
  while ($bar=each($sites)) {
    echo "<tr><td>$bar[1]</td><td>$bar[0]</td><td>";
    $table = $bar[0];
    $tables[] = $table."_pages";
    $tables[] = $table."_acces";
    $tables[] = $table."_host";
    $tables[] = $table."_country";
    $tables[] = $table."_hour";
    $tables[] = $table."_day";
    $tables[] = $table."_os";
    $tables[] = $table."_browser";
    $tables[] = $table."_keyword";
    $tables[] = $table."_referrer"; 
    foreach ($tables as $thetable) {
      // Get size of table
      $result = mysql_query ("show table status like '$thetable'",$c);
      $row = mysql_fetch_array($result);
      $number_line = $row['Rows'];      // Get number of lines in tables
      $table_size = number_format(($row['Data_length'] + $row['Index_length'])/1024,1);
      echo "$thetable: $number_line rows, $table_size kb<br>";
    }
    echo "</td></tr>";
    unset($tables);
  }  
  @mysql_close ($c);
  echo "</table>";
}

/*********************************************************************************/
/* Function: diskUsageTable
/* Role: returns the total disk usage for a set of tables
/* Parameters: 
/*  - $table: table root
/* Output:
*   - disk usage in kb
/* Created: 06/2004
/*********************************************************************************/
function diskUsageTable ($table) {
  global $server;
  global $user;
  global $password;
  global $base;
  
  $c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
  $db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");
  $tables[] = $table."_pages";
  $tables[] = $table."_acces";
  $tables[] = $table."_host";
  $tables[] = $table."_country";
  $tables[] = $table."_hour";
  $tables[] = $table."_day";
  $tables[] = $table."_os";
  $tables[] = $table."_browser";
  $tables[] = $table."_keyword";
  $tables[] = $table."_referrer";
  $table_size = 0;
  foreach ($tables as $thetable) {
    // Get size of table
    $result = mysql_query ("show table status like '$thetable'",$c);
    $row = mysql_fetch_array($result);
    // $number_line = $row['Rows'];      // Get number of lines in tables
    $table_size += ($row['Data_length'] + $row['Index_length'])/1024;
  }
  @mysql_close ($c);
  $table_size = number_format($table_size,1);
  return $table_size;
}

/*********************************************************************************/
/* Function: clearDB
/* Role: delete content of log tables (WATCH OUT, IT REALLY CLEARS IT ALL!!!)
/* Parameters: 
/*   - $table: base name for tables
/* Output: none
/* Created 05/2004
/*********************************************************************************/
function clearDB($table) {
  global $DEBUG;
  global $server;
  global $user;
  global $password;
  global $base;
  global $config_table;
  
  // pages
  $table_p = $table."_pages";
  // acces
  $table_a = $table."_acces";
  // hosts
  $table_host = $table."_host";
  // country
  $table_c = $table."_country";
  // hour
  $table_hour = $table."_hour";
  // day
  $table_day = $table."_day";
  // os
  $table_os = $table."_os";
  // browser
  $table_b = $table."_browser";
  // keywords
  $table_k = $table."_keyword";
  // referrer
  $table_r = $table."_referrer";

  // connect to database
  if ($DEBUG == 1) {echo "<br>Trying to connect";}
  $c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
  $db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");
  // Clear up tables
  $sql= "TRUNCATE TABLE `$table_a`";
  echo "<br>Clearing up $table_a";
  $res = mysql_query($sql,$c);
  $sql= "TRUNCATE TABLE `$table_host`";
  echo "<br>Clearing up $table_host";
  $res = mysql_query($sql,$c);
  $sql= "TRUNCATE TABLE `$table_c`";
  echo "<br>Clearing up $table_c";
  $res = mysql_query($sql,$c);
  $sql= "TRUNCATE TABLE `$table_os`";
  echo "<br>Clearing up $table_os";
  $res = mysql_query($sql,$c);
  $sql= "TRUNCATE TABLE `$table_b`";
  echo "<br>Clearing up $table_b";
  $res = mysql_query($sql,$c);
  $sql= "TRUNCATE TABLE `$table_k`";
  echo "<br>Clearing up $table_k";
  $res = mysql_query($sql,$c);
  $sql= "TRUNCATE TABLE `$table_r`";
  echo "<br>Clearing up $table_r";
  $res = mysql_query($sql,$c);
  $sql= "TRUNCATE TABLE `$table_p`";
  echo "<br>Clearing up $table_p";  
  $res = mysql_query($sql,$c);
  $sql = "UPDATE `$table_hour` SET count=0";
  echo "<br>Clearing up $table_hour";
  $res = mysql_query($sql,$c);
  $sql = "UPDATE `$table_day` SET count=0";
  echo "<br>Clearing up $table_day";
  $res = mysql_query($sql,$c);
  @mysql_close ($c);
}

/*********************************************************************************/
/* Function: deleteDB
/* Role: delete log tables (WATCH OUT, IT REALLY CLEARS IT ALL!!!)
/* Parameters: 
/*   - $table: base name for tables
/* Output: none
/* Created 06/2004
/*********************************************************************************/
function deleteDB($table) {
  global $DEBUG;
  global $server, $user, $password, $base, $config_table;
  global $version, $ip2c, $dirFlags, $extFlag, $sites;

  // Clear the tables 
  clearDB($table);

  // Delete the tables
  $tables[] = $table."_pages";
  $tables[] = $table."_acces";
  $tables[] = $table."_host";
  $tables[] = $table."_country";
  $tables[] = $table."_hour";
  $tables[] = $table."_day";
  $tables[] = $table."_os";
  $tables[] = $table."_browser";
  $tables[] = $table."_keyword";
  $tables[] = $table."_referrer";
  if ($DEBUG == 1) {echo "<br>Trying to connect";}
  $c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
  $db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");

  foreach ($tables as $thisone) {
    $sql= "DROP TABLE `$thisone`";
    echo "<br>Deleting table $thisone";
    $res = mysql_query($sql,$c);
  }
  @mysql_close ($c);

  // Remove line from configuration
  $temp = fopen ("./sites.php", 'w');
  fwrite($temp, "<?\n 
// Sites beging audited
\$sites = array( ");
  $i = 0;
  while ($bar=each($sites)) {
    if ($bar[0] != $table) {
      if ($i==0) {
	fwrite($temp, "\n\"$bar[0]\"=>\"$bar[1]\"");
      }  else {
	fwrite($temp, "\n,\"$bar[0]\"=>\"$bar[1]\"");
      }
      $i+=1;
    }
  }
  fwrite($temp, ");\n?>");
  fclose($temp);  
}
?>