<?
/***************************************************************************
 phpTrafficA @soft.ZoneO.net
 Copyright (C) 2004 ZoneO-soft, S. Merkel (dude@zoneo.net)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/
include("./phplot.php");
include("./".$file);

function hex2rgb($hex) {
   $color = str_replace('#','',$hex);
   $rgb = array(hexdec(substr($color,0,2)),
                hexdec(substr($color,2,2)),
                hexdec(substr($color,4,2)));
   return $rgb;
 } 

$dark = hex2rgb("#122C4D");
$maxYY = floor($maxY/10)*10+10;
$tickStep = floor($maxYY/4);

$graph = new PHPlot($width,$height);
$graph->SetGridColor($dark);
$graph->SetLightGridColor($dark);
$graph->SetFont("x_label",2);
$graph->SetFont("y_label",2);
$graph->SetDataType("data-data");  //Must be called before SetDataValues
$graph->SetXGridLabelType("time");
$graph->SetXDataLabelAngle(90);
$graph->SetXLabel("");
$graph->SetYLabel("");
$graph->SetVertTickIncrement($tickStep);
$graph->SetXTimeFormat("%b %y");
$graph->SetDataValues($date_data);
$graph->SetColor($dark);
// if data for more than three month, monthly ticks in X
if (($end-$start) > (3*2679000)) {
  $graph->SetHorizTickIncrement(2679000);
// if data for more than two week, weekly ticks in X
} elseif  (($end-$start) > (2*604800)) {
  $graph->SetHorizTickIncrement(604800);
  $graph->SetXTimeFormat("%e %b") ;
} else {
  $graph->SetHorizTickIncrement(86400);
  $graph->SetXTimeFormat("%a %e") ;
}
$graph->SetPlotType("$plottype");
$graph->SetDrawXDataLabels(false);
$graph->SetPlotAreaWorld($start,0,$end,$maxYY);
$graph->SetDataColors( array( "red","blue","orange","green","violet", "black","peru", "aquamarine1","DarkGreen"), array( "black","black", "black", "black", "black", "black","black","black","black") );
// $graph->SetLegendPixel(500,0,"");
$graph->SetLineStyles('solid');
if (isset($legende)) {
  $graph->SetLegend($legende);
}
$graph->SetLineWidth(2); 
$graph->DrawGraph();



?>