<?php
/***************************************************************************
 phpTrafficA @soft.ZoneO.net
 Copyright (C) 2004 ZoneO-soft, S. Merkel (dude@zoneo.net)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/
/*********************************************************************************/
/* Function: echoOS
/* Role: stats results on operating system
/* Parameters: 
/*   - $table: base name for sql tables
/*   - $site: root of the website
/* Output:
/*   - nothing, but echos whatever it finds
/* Created: 06/2004
/*********************************************************************************/
function echoOS($table, $site) {
  echoMonthly($table,$site,"os");
}

/*********************************************************************************/
/* Function: echoOS
/* Role: stats results on web browsers
/* Parameters: 
/*   - $table: base name for sql tables
/*   - $site: root of the website
/* Output:
/*   - nothing, but echos whatever it finds
/* Created: 06/2004
/*********************************************************************************/
function echoBrowser($table, $site) {
  echoMonthly($table,$site,"browser");
}

/*********************************************************************************/
/* Function: echoOS
/* Role: stats results on countries
/* Parameters: 
/*   - $table: base name for sql tables
/*   - $site: root of the website
/* Output:
/*   - nothing, but echos whatever it finds
/* Created: 06/2004
/*********************************************************************************/
function echoCountry($table, $site) {
  echoMonthly($table,$site,"country");
}

/*********************************************************************************/
/* Function: countryNameFlag
/* Role: converts the 2 chars string into full country name 
/*    and flag 
/* Parameters: 
/*   - $c: 2 chars country string
/* Output:
/*   - string, with image link to the flag and full country name
/* Source: ip2c, http://hot-things.net
/* Created: 06/2004
/*********************************************************************************/
function countryNameFlag($c) {
  global $ip2c;
  global $extFlag;
  global $dirFlags;
  $ty=strtolower($c);
  $ty=str_replace("\n","",$ty);
  switch($ty){
    case'ac':$rz='Ascension Island';break;
    case'ad':$rz='Andorra';break;
    case'ae':$rz='United Arab Emirates';break;
    case'af':$rz='Afghanistan';break;
    case'ag':$rz='Antigua and Barbuda';break;
    case'ai':$rz='Anguilla';break;
    case'al':$rz='Albania';break;
    case'am':$rz='Armenia';break;
    case'an':$rz='Netherlands Antilles';break;
    case'ao':$rz='Angola';break;
    case'aq':$rz='Antarctica';break;
    case'ar':$rz='Argentina';break;
    case'as':$rz='American Samoa';break;
    case'at':$rz='Austria';break;
    case'au':$rz='Australia';break;
    case'aw':$rz='Aruba';break;
    case'az':$rz='Azerbaijan';break;
    case'ba':$rz='Bosnia and Herzegowina';break;
    case'bb':$rz='Barbados';break;
    case'bd':$rz='Bangladesh';break;
    case'be':$rz='Belgium';break;
    case'bf':$rz='Burkina Faso';break;
    case'bg':$rz='Bulgaria';break;
    case'bh':$rz='Bahrain';break;
    case'bi':$rz='Burundi';break;
    case'bj':$rz='Benin';break;
    case'bm':$rz='Bermuda';break;
    case'bn':$rz='Brunei Darussalam';break;
    case'bo':$rz='Bolivia';break;
    case'br':$rz='Brazil';break;
    case'bs':$rz='Bahamas';break;
    case'bt':$rz='Bhutan';break;
    case'bv':$rz='Bouvet Island';break;
    case'bw':$rz='Botswana';break;
    case'by':$rz='Belarus';break;
    case'bz':$rz='Belize';break;
    case'ca':$rz='Canada';break;
    case'cc':$rz='Cocos (Keeling) Islands';break;
    case'cd':$rz='Zaire';break;
    case'cf':$rz='Central African Republic';break;
    case'cg':$rz='Congo';break;
    case'ch':$rz='Switzerland';break;
    case'ci':$rz='Cote d\'Ivoire';break;
    case'ck':$rz='Cook Islands';break;
    case'cl':$rz='Chile';break;
    case'cm':$rz='Cameroon';break;
    case'cn':$rz='China';break;
    case'co':$rz='Colombia';break;
    case'cr':$rz='Costa Rica';break;
    case'cs':$rz='Czechoslovakia (former)';break;
    case'cu':$rz='Cuba';break;
    case'cv':$rz='Cape Verde';break;
    case'cx':$rz='Christmas Island';break;
    case'cy':$rz='Cyprus';break;
    case'cz':$rz='Czech Republic';break;
    case'de':$rz='Germany';break;
    case'dj':$rz='Djibouti';break;
    case'dk':$rz='Denmark';break;
    case'dm':$rz='Dominica';break;
    case'do':$rz='Dominican Republic';break;
    case'dz':$rz='Algeria';break;
    case'ec':$rz='Ecuador';break;
    case'ee':$rz='Estonia';break;
    case'eg':$rz='Egypt';break;
    case'eh':$rz='Western Sahara';break;
    case'er':$rz='Eritrea';break;
    case'es':$rz='Spain';break;
    case'et':$rz='Ethiopia';break;
    case'fi':$rz='Finland';break;
    case'fj':$rz='Fiji';break;
    case'fk':$rz='Falkland Islands';break;
    case'fm':$rz='Micronesia';break;
    case'fo':$rz='Faroe Islands';break;
    case'fr':$rz='France';break;
    case'fx':$rz='France, Metropolitan';break;
    case'ga':$rz='Gabon';break;
    case'gb':$rz='United Kingdom';break;
    case'gd':$rz='Grenada';break;
    case'ge':$rz='Georgia';break;
    case'gf':$rz='French Guiana';break;
    case'gg':$rz='Guernsey';break;
    case'gh':$rz='Ghana';break;
    case'gi':$rz='Gibraltar';break;
    case'gl':$rz='Greenland';break;
    case'gm':$rz='Gambia';break;
    case'gn':$rz='Guinea';break;
    case'gp':$rz='Guadelope';break;
    case'gq':$rz='Equatorial Guinea';break;
    case'gr':$rz='Greece';break;
    case'gs':$rz='Sth Georgia &Sth Sandwich Is.';break;
    case'gt':$rz='Guatemala';break;
    case'gu':$rz='Guam';break;
    case'gw':$rz='Guinea-Bissau';break;
    case'gy':$rz='Guyana';break;
    case'hk':$rz='Hong Kong';break;
    case'hm':$rz='Heard and McDonald Islands';break;
    case'hn':$rz='Honduras';break;
    case'hr':$rz='Croatia';break;
    case'ht':$rz='Haiti';break;
    case'hu':$rz='Hungary';break;
    case'id':$rz='Indonesia';break;
    case'ie':$rz='Ireland';break;
    case'il':$rz='Israel';break;
    case'im':$rz='Isle of Man';break;
    case'in':$rz='India';break;
    case'io':$rz='British Indian Ocean Terr.';break;
    case'iq':$rz='Iraq';break;
    case'ir':$rz='Iran';break;
    case'is':$rz='Iceland';break;
    case'it':$rz='Italy';break;
    case'je':$rz='Jersey';break;
    case'jm':$rz='Jamaica';break;
    case'jo':$rz='Jordan';break;
    case'jp':$rz='Japan';break;
    case'ke':$rz='Kenya';break;
    case'kg':$rz='Kyrgystan';break;
    case'kh':$rz='Cambodia';break;
    case'ki':$rz='Kiribati';break;
    case'km':$rz='Comoros';break;
    case'kn':$rz='Saint Kitts and Nevis';break;
    case'kp':$rz='Korea, DPR';break;
    case'kr':$rz='Korea, Republic of';break;
    case'kw':$rz='Kuwait';break;
    case'ky':$rz='Cayman Islands';break;
    case'kz':$rz='Kazakhstan';break;
    case'la':$rz='Lao PDR';break;
    case'lb':$rz='Lebanon';break;
    case'lc':$rz='Saint Lucia';break;
    case'li':$rz='Liechtenstein';break;
    case'lk':$rz='Sri Lanka';break;
    case'lr':$rz='Liberia';break;
    case'ls':$rz='Lesotho';break;
    case'lt':$rz='Lithuania';break;
    case'lu':$rz='Luxembourg';break;
    case'lv':$rz='Latvia';break;
    case'ly':$rz='Libyan Arab Jamahiriya';break;
    case'ma':$rz='Morocco';break;
    case'mc':$rz='Monaco';break;
    case'md':$rz='Moldova';break;
    case'mg':$rz='Madagascar';break;
    case'mh':$rz='Marshall Islands';break;
    case'mk':$rz='Macedonia';break;
    case'ml':$rz='Mali';break;
    case'mm':$rz='Myanmar';break;
    case'mn':$rz='Mongolia';break;
    case'mo':$rz='Macau';break;
    case'mp':$rz='Northern Mariana Is.';break;
    case'mq':$rz='Martinique';break;
    case'mr':$rz='Mauritania';break;
    case'ms':$rz='Montserrat';break;
    case'mt':$rz='Malta';break;
    case'mu':$rz='Mauritius';break;
    case'mv':$rz='Maldives';break;
    case'mw':$rz='Malawi';break;
    case'mx':$rz='Mexico';break;
    case'my':$rz='Malaysia';break;
    case'mz':$rz='Mozambique';break;
    case'na':$rz='Namibia';break;
    case'nc':$rz='New Caledonia';break;
    case'ne':$rz='Niger';break;
    case'nf':$rz='Norfolk Island';break;
    case'ng':$rz='Nigeria';break;
    case'ni':$rz='Nicaragua';break;
    case'nl':$rz='The Netherlands';break;
    case'no':$rz='Norway';break;
    case'np':$rz='Nepal';break;
    case'nr':$rz='Nauru';break;
    case'nt':$rz='Neutral Zone';break;
    case'nu':$rz='Niue';break;
    case'nz':$rz='New Zealand';break;
    case'om':$rz='Oman';break;
    case'pa':$rz='Panama';break;
    case'pe':$rz='Peru';break;
    case'pf':$rz='French Polynesia';break;
    case'pg':$rz='Papua New Guinea';break;
    case'ph':$rz='Philippines';break;
    case'pk':$rz='Pakistan';break;
    case'pl':$rz='Poland';break;
    case'pm':$rz='St. Pierre and Miquelon';break;
    case'pn':$rz='Pitcairn';break;
    case'pr':$rz='Puerto Rico';break;
    case'pt':$rz='Portugal';break;
    case'pw':$rz='Palau';break;
    case'py':$rz='Paraguay';break;
    case'qa':$rz='Qatar';break;
    case're':$rz='Reunion';break;
    case'ro':$rz='Romania';break;
    case'ru':$rz='Russia';break;
    case'rw':$rz='Rwanda';break;
    case'sa':$rz='Saudi Arabia';break;
    case'sb':$rz='Solomon Islands';break;
    case'sc':$rz='Seychelles';break;
    case'sd':$rz='Sudan';break;
    case'se':$rz='Sweden';break;
    case'sg':$rz='Singapore';break;
    case'sh':$rz='St. Helena';break;
    case'si':$rz='Slovenia';break;
    case'sj':$rz='Svalbard and Jan Mayen Is.';break;
    case'sk':$rz='Slovakia';break;
    case'sl':$rz='Sierra Leone';break;
    case'sm':$rz='San Marino';break;
    case'sn':$rz='Senegal';break;
    case'so':$rz='Somalia';break;
    case'sr':$rz='Surinam';break;
    case'st':$rz='Sao Tome and Principe';break;
    case'su':$rz='USSR';break;
    case'sv':$rz='El Salvador';break;
    case'sy':$rz='Syrian Arab Republic';break;
    case'sz':$rz='Swaziland';break;
    case'tc':$rz='The Turks & Caicos Islands';break;
    case'td':$rz='Chad';break;
    case'tf':$rz='French Southern Territories';break;
    case'tg':$rz='Togo';break;
    case'th':$rz='Thailand';break;
    case'tj':$rz='Tajikistan';break;
    case'tk':$rz='Tokelau';break;
    case'tm':$rz='Turkmenistan';break;
    case'tn':$rz='Tunisia';break;
    case'to':$rz='Tonga';break;
    case'tp':$rz='East Timor';break;
    case'tr':$rz='Turkey';break;
    case'tt':$rz='Trinidad and Tobago';break;
    case'tv':$rz='Tuvalu';break;
    case'tw':$rz='Taiwan';break;
    case'tz':$rz='Tanzania';break;
    case'ua':$rz='Ukraine';break;
    case'ug':$rz='Uganda';break;
    case'uk':$rz='United Kingdom';break;
    case'um':$rz='United States M.O Is.';break;
    case'us':$rz='United States';break;
    case'uy':$rz='Uruguay';break;
    case'uz':$rz='Uzbekistan';break;
    case'va':$rz='Holy See (Vatican)';break;
    case'vc':$rz='St Vincent & Grenadines';break;
    case've':$rz='Venezuela';break;
    case'vg':$rz='Virgin Islands British';break;
    case'vi':$rz='Virgin Islands U.S';break;
    case'vn':$rz='Vietnam';break;
    case'vu':$rz='Vanuatu';break;
    case'wf':$rz='Wallis and Futuna Islands';break;
    case'ws':$rz='Samoa';break;
    case'ye':$rz='Yemen';break;
    case'yt':$rz='Mayotte';break;
    case'yu':$rz='Yugoslavia';break;
    case'za':$rz='South Africa';break;
    case'zm':$rz='Zambia';break;
    case'zr':$rz='Zaire';break;
    case'zw':$rz='Zimbabwe';break;
  default:$rz='';break;
  }
  $img="$dirFlags/$ty.$extFlag";
  if(is_file($img)) {
    $string = "<img src=\"$img\"alt=\"$rz\"> $rz";
  } else {
    $string = "$rz";
  }
  return $string;
}

/*********************************************************************************/
/* Function: echoMonthly
/* Role: stats results for monthly quantity, such as OS, browser, or country
/* Parameters: 
/*   - $table: base name for sql tables
/*   - $site: root of the website
/*   - $what: can be "os", "browser", "country"
/* Output:
/*   - nothing, but echos whatever it finds
/* Created: 06/2004
/*********************************************************************************/
function echoMonthly($table, $site, $what) {
  global $DEBUG;
  global $server;
  global $user;
  global $password;
  global $base;
  global $config_table;
  
  $today = date("Y-m-d");
  $thismonth = date("Y-m-01");
  $lastmonth = date("Y-m-01",strtotime("-1 month"));
  $lastlastmonth = date("Y-m-01",strtotime("-2 month"));
  // echo "<br>This month, $thismonth, last month, $lastmonth, 2 month ago, $lastlastmonth";
  
  $c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
  $db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");  
  
  // QTY plots
  // get the most popular QTY
  $req = "SELECT date,label,SUM(count) as count FROM ${table}_$what WHERE date<='$thismonth' GROUP BY label ORDER BY count DESC;";
  $res = mysql_query($req,$c);
  $nQTY = 0;
  $bigTotal = 0;
  while($row = mysql_fetch_object($res)) {
    $qty[$nQTY] = $row->label;
    $count[$nQTY] = $row->count;
    $bigTotal += $count[$nQTY];
    // echo "<br>$nQTY- $qty[$nQTY]: $count[$nQTY]";
    $nQTY += 1;
  }
  // Pull number of counts for each month
  $req = "SELECT date,SUM(count) as count FROM ${table}_$what GROUP BY date;";
  $res = mysql_query($req,$c);
  $nMonth = 0;
  $date = array();
  $total = array();
  while($row = mysql_fetch_object($res)) {
      $date[$nMonth] = $row->date;
      $total[$nMonth] = $row->count;
      // echo "<br>$nMonth- $date[$nMonth]: $total[$nMonth]";
      $nMonth += 1;
  }
  // Ok, for the all used QTY, get the monthly data
  for ($i=0;$i<$nMonth;$i++) {
    for ($j=0;$j<$nQTY;$j++) {
      $req = "SELECT count FROM ${table}_$what WHERE label='$qty[$j]' AND date='$date[$i]';";
      $res = mysql_query($req,$c);
      $row = mysql_fetch_array($res);
      $datecount[$i][$j] = $row['count'];
      if ($datecount[$i][$j] == "") {
	$datecount[$i][$j] = "0";
      }
      // echo "<br>For $qty[$j] in $date[$i], we have ".$datecount[$i][$j]." counts, compared to ".$row['count'].".";
    }
  }
  $start = 100000000000;
  $end = 0;
  $maxcount = 0;
  $temp = fopen ("./tmp.txt.php", 'w');
  fwrite($temp, "<?\n\$date_data = array(");
  $max = min($nQTY,8);
  for ($i=0;$i<$nMonth;$i++) {
    $time = strtotime($date[$i]);
    if ($time<$start) {$start=$time;}
    if ($time>$end) {$end=$time;}
    if ($i>0) {
      fwrite($temp,"\n,array(\"\",$time");
    } else {
      fwrite($temp,"\narray(\"\",$time");
    }
    for ($j=0;$j<$max;$j++) {
      $tt = (100.*$datecount[$i][$j]/$total[$i]);
      if ($tt>$maxcount) {$maxcount = $tt;}
      fwrite($temp,",$tt");
    }
    $other = 0;
    for ($j=$max;$j<$nQTY;$j++) {
      $other += 100.*$datecount[$i][$j]/$total[$i];
    }
    if ($other>$maxcount) {$maxcount=$tt;}
    fwrite($temp, ",$other)");
  }
  $end += 2679000;
  $legende = "\"$qty[0]\"";
  for ($j=1;$j<$max;$j++) {
    $legende .= ",\"$qty[$j]\"";
  }
  $legende .= ",\"Other\"";
  fwrite($temp, "\n);\n\$start=$start;\n\$end=$end;\n\$maxY=$maxcount;\n\$plottype=\"lines\";"); 
  fwrite($temp, "\n\$legende = array($legende);");
  fwrite($temp, "\n\$width = 600;");
  fwrite($temp, "\n\$height = 400;");
  fwrite($temp, "\n?>");
  fclose($temp);
  if ((($start+2679000) != $end)&&$maxcount>0) {
    echo "<table class='stat'>
<tr><td class='title'>History</td></tr>
<tr><td><center><img src='./plotStat.php?file=tmp.txt.php'></center></tr>
</table><br>"; 
  } else {
    echo "<table class='stat'>
<tr><td class='title'>History</td></tr>
<tr><td><center>&nbsp;<br>Not enough history. Come back later!<BR>&nbsp;</center></tr>
</table><br>"; 
  }

  // This month
  // get the most popular QTY
  $req = "SELECT label,count FROM ${table}_$what WHERE date='$thismonth' ORDER BY count DESC;";
  $res = mysql_query($req,$c);
  $thismonthNQty = 0;
  $totalthismonth = 0;
  while($row = mysql_fetch_object($res)) {
    $thismonthqty[$thismonthNQty] = $row->label;
    $thismonthcount[$thismonthNQty] = $row->count;
    // echo "<br>$thismonth- $qty[$nQTY]: $count[$nQTY]";
    $thismonthNQty += 1;
    $totalthismonth += $row->count;
  }
  if ($totalthismonth > 0) {
    $temp = fopen ("./tmp2.txt.php", 'w');
    fwrite($temp, "<?\n\$date_data = array(");
    $max = min($thismonthNQty,6);
    for ($j=0;$j<$max;$j++) {
      $tt = $thismonthcount[$j];
      if ($j>0) {
	fwrite($temp,",$tt");
      } else {
	fwrite($temp,"array(\"\",$tt");
      }
    }
    $other = 0;
    for ($j=$max;$j<$nQTY;$j++) {
      $other += $thismonthcount[$j];
    }
    fwrite($temp,",$other)");
    $legende = "\"$thismonthqty[0]\"";
    for ($j=1;$j<$max;$j++) {
      $legende .= ",\"$thismonthqty[$j]\"";
    }
    $legende .= ",\"Other\"";
    fwrite($temp, "\n);\n\$plottype=\"pie\";");
    fwrite($temp, "\n\$legende = array($legende);");
    fwrite($temp, "\n\$width = 500;");
    fwrite($temp, "\n\$height = 200;");
    fwrite($temp, "\n?>");
    fclose($temp);
    echo "<table class='stat'>
<tr><td class='title'>This month</td></tr>
<tr><td><center><img src='./plotStatPie.php?file=tmp2.txt.php'></center></tr>
</table><br>"; 
  } else {
    echo "<table class='stat'>
<tr><td class='title'>This month</td></tr>
<tr><td><center>&nbsp;<br>No access recorded during for the month: $thismonth<br>&nbsp;</center></tr>
</table><br>"; 
  }

  

  // Table with numbers
  echo "<table class='stat'>
<tr><td class='title' colspan='9'>Recent statistics</td></tr>
<tr><td class='caption'></td><td class='caption' colspan='2'>This month</td><td class='caption' colspan='2'>Last month</td><td class='caption' colspan='2'>Two month ago</td><td class='caption' colspan='2'>Total</td></tr>
<tr><td>Total number of access</td>";
  $toPull[0] = $thismonth;
  $toPull[1] = $lastmonth;
  $toPull[2] = $lastlastmonth;
  for ($i=0;$i<3;$i++) {
    $index = array_search("$toPull[$i]", $date);
    if($index === FALSE) {
      echo "<td colspan='2'>0</td>";
    } else {
      echo "<td colspan='2'>".$total[$index]."</td>";
    }
  }
  echo "<td colspan='2'>".$bigTotal."</td>";
  echo "</tr>";
  for ($j=0;$j<$nQTY;$j++) {
    if ($what == "country") {
      echo "\n<tr><td>".countryNameFlag($qty[$j])."</td>";
    } else {
      echo "\n<tr><td>$qty[$j]</td>";
    }
    for ($i=0;$i<3;$i++) {
      $index = array_search("$toPull[$i]", $date);
      if($index === FALSE){
	$tt = 0;
	$tt2 = 0;
      } else { 
	if ($total[$index] != 0) {
	  $tt = number_format((100.*$datecount[$index][$j]/$total[$index]),1);
	  $tt2 = $datecount[$index][$j];
	} else {
	  $tt = 0;
	  $tt2 = 0;
	}
      }
      echo "<td>$tt2</td><td>$tt%</td>";
    }
    $tt =  number_format((100.*$count[$j]/$bigTotal),1);
    echo "<td>".$count[$j]."</td><td>$tt%</td>";
    echo "</tr>";
  }
  echo "\n</table>";
  @mysql_close ($c);
}

?>
